/*
 * @(#)iodm.h: $Revision: 1.16.106.1 $ $Date: 97/07/07 18:22:49 $
 * $Locker: CRT $
 *
 */

typedef int 	 terminal_ctrl_type;
typedef int 	 buff_data_type;
 
/*=============================== dtapectl ===============================*/
 

#define REWIND		    1  
#define REWIND_UNLOAD	    2  
#define WRITE_TAPE_MARK	    3  
#define FORWARD_FILE	    4  
#define BACKWARD_FILE	    5  
#define FORWARD_RECORD	    6  
#define BACKWARD_RECORD	    7  
#define GAP_TAPE	    8  
#define SET_DENSITY	    9	/* 7976 & 7978				      */
#define SET_COMPRESSION     10
#define REMOTE_UNLOAD       11  /* DDS devices only */
#define SET_START_STOP	    12	/* 7974 only				      */
#define SET_STREAMING	    13	/* 7974 only				      */
#define SET_IMMEDIATE	    14	/* 7974 & 7978				      */
#define SET_NON_IMMEDIATE   15	/* 7974 & 7978				      */
#define SEEK_TO_EOD         16
#define WRITE_SETMARK       17
#define FORWARD_SETMARK     18
#define BACK_SETMARK        19	
#define INQUIRY_INFO        20  /* SCSI devices only */
#define XSENSE_INFO         21  /* SCSI devices only */
#define SOFTWARE_STATUS	    22	
#define DISPLAY_FUNC	    23
#define MOVE_MEDIUM	    24
#define LSSF_INQUIRY_INFO   25  /* SCSI devices only */
#define MAX_TAPE_OPTIONS    25

typedef bit8 tape_ctrl_type; 

typedef struct {
    ushort   transport;
    ushort   source;
    ushort   destination;
    ushort   invert;                  /* don't care */
} tape_acl_ctrl_type; 

/*=============================== dserlctl ===============================*/
 

#define ENABLE_PSEUDO_EOF   1  
#define DISABLE_PSEUDO_EOF  2  
#define SET_EOF_CONDITION   3  
#define CLEAR_EOF_CONDITION 4  
#define SET_PRE_SPACE_MODE  5  
#define SET_POST_SPACE_MODE 6  
#define SET_CRITICAL_MODE   7  
#define CLEAR_CRITICAL_MODE 8  
#define MAX_SERIAL_CTRL	    8  

typedef bit8 serial_option_type; 

typedef struct { 
    serial_option_type serial_option; 
} serial_ctrl_type; 
 
/*=============================== drandctl ===============================*/
 

/* 05/12/84  Chris T. Hugins  Added "cs80_transparent".			      */

typedef bit32 disc_addr;      /*logical disc sector address		      */
typedef bit32 disc_len;	      /*byte count for disc transfer		      */
typedef bit8  disc_direction; /*DMA direction				      */

#define FROM_DEVICE ((disc_direction) 0)  
#define TO_DEVICE   ((disc_direction) 1) 

typedef bit8 adr_mode; /* Logical disc address or physical (C/H/S)	      */

#define SINGLE_VECTOR ((adr_mode) 0)	 
#define THREE_VECTOR  ((adr_mode) 1)	 

typedef bit8 random_control; 

#define INIT_MEDIA   ((random_control) 0) /*initialize media */
#define REQ_LIMIT    ((random_control) 1) /*request volume limits	*/
#define VERIFY	     ((random_control) 2) /*verify media */
#define LOCK	     ((random_control) 3) /*lock operator interface (disable) */
#define UNLOCK	     ((random_control) 4) /*enable operator interface */
#define SENSE_LOCK   ((random_control) 5) /*return lock state */
#define IDENTIFY     ((random_control) 6) /*return HP-IB identify string */
#define GENERAL_CMD  ((random_control) 7) /*issue CS80 command sequence from user */
#define SET_RPS	     ((random_control) 8) /*set rotational position sense times */
#define SPARE_BLOCK  ((random_control) 9) /*spare media block */
#define DEVICE_CLEAR ((random_control) 10) /*perform selected-device clear (HP-IB) */
#define LOOPBACK_WRT ((random_control) 11) /*perform loopback write */
#define LOOPBACK_RD  ((random_control) 12) /*perform loopback read */

typedef struct { 

    unsigned char dont_retain_field:1;	 /*don't retain field spares	      */
    unsigned char dont_retain_factory:1; /*don't retain factory spares	      */
    bit8	  interleave;		 /*sector interleave factor	      */

} init_media_type; 

typedef struct { 

    disc_addr verify_address; /*address to begin verify			      */
    disc_len  verify_length;  /*bytes to verify				      */

} verify_type; 

typedef struct { 

    bit8	   cmd_bytes[(15)+1];  /* CS80 cmd			      */
				       /*bytes.				      */
    bit8	   cmd_length;	       /*number of cmd bytes to send	      */
    disc_direction direction;	       /*direction of data		      */
				       /*flow in execution message.	      */
    unsigned char  execution_msg:1;    /*true if there is an execu-	      */
				       /*tion message.			      */
    unsigned char  cs80_transparent:1; /* Is cmd for DA to intercept?	      */

} general_cmd_type; 

typedef struct { 

    bit8 rps_time;   /*time-to-target in 100's of MS			      */
    bit8 rps_window; /*time RPS window open in 100's of MS		      */

} set_rps_type; 

typedef struct { 

    disc_addr	  spare_da;	    /*set to the logical disc address	      */
				    /*of where verification should	      */
				    /*begin.				      */
    unsigned char no_retain_data:1; /*don't retain data on spare oper-	      */
				    /*ation.  This should be true when	      */
				    /*sector sparing fails and track	      */
				    /*sparing is to occur.		      */
    bit8	  mode_byte;	    /*sparing mode byte-device specific	      */

} spare_block_type; 

typedef struct { 

    adr_mode limit_format; /*Set to single_vector for logical		      */
			   /*addressing, or three_vector for		      */
			   /*physical addressing.			      */
} limit_fmt_type; 

typedef struct { 
    random_control random_cntl; 

    union { 
	init_media_type	 init_media_rec; 
	limit_fmt_type	 limit_fmt; 
	verify_type	 verify_rec; 

	general_cmd_type general_cmd_rec; 
	set_rps_type	 set_rps_rec; 
	spare_block_type spare_block_rec; 

    } u; 
} addr_ctrl_type; 

 
/*=============================== dprntctl ===============================*/
 
/* Character Sets							      */

typedef bit8 std_char_sets; 

#define USASCII		 ((std_char_sets) 0) 
#define ARABIC		 ((std_char_sets) 1) 
#define CYRILLIC	 ((std_char_sets) 2) 
#define KATAKANA	 ((std_char_sets) 3) 
#define DRAW		 ((std_char_sets) 4) 
#define BLOCK		 ((std_char_sets) 5) 
#define MATH		 ((std_char_sets) 6) 
#define APL		 ((std_char_sets) 7) 
#define FRENCH		 ((std_char_sets) 8) 
#define GERMAN		 ((std_char_sets) 9) 
#define SWEDISH_FINNISH	 ((std_char_sets) 10) 
#define DANISH_NORWEGIAN ((std_char_sets) 11) 
#define SPANISH		 ((std_char_sets) 12) 
#define BRITISH		 ((std_char_sets) 13) 
#define JAPANESE_ASCII	 ((std_char_sets) 14) 
#define ROMAN_EXTENSION	 ((std_char_sets) 15) 
#define MAX_CHAR_SETS	 ((std_char_sets) 15) 

/* Printer Control							      */

typedef bit8 printer_ctrl_func_type; 

#define START_PERF_SKIP		  ((printer_ctrl_func_type) 1) 
#define END_PERF_SKIP		  ((printer_ctrl_func_type) 2) 
#define SELECT_CHAR_SET		  ((printer_ctrl_func_type) 3) 
#define PHYSICAL_PAGE_LEN	  ((printer_ctrl_func_type) 4) 
#define LOGICAL_PAGE_LEN	  ((printer_ctrl_func_type) 5) 
#define SET_LEFT_MARGIN		  ((printer_ctrl_func_type) 6) 
#define DOWNLOAD_VFC		  ((printer_ctrl_func_type) 7) 
#define SILENT_RECOVERY		  ((printer_ctrl_func_type) 8) 
#define CPR_CLEAR		  ((printer_ctrl_func_type) 9) 
#define CPR_BEGIN_JOB		  ((printer_ctrl_func_type) 10) 
#define CPR_END_JOB		  ((printer_ctrl_func_type) 11) 
#define CPR_INTERPRET_ESC_CODES	  ((printer_ctrl_func_type) 12) 
#define CPR_SET_CONTROL_MASK	  ((printer_ctrl_func_type) 13) 
#define CPR_SEND_PENDING_BUFFERS  ((printer_ctrl_func_type) 14) 
#define CPR_PERIPHERAL_ENVIR	  ((printer_ctrl_func_type) 15) 
#define CPR_REPORT_AVAIL_STATUS	  ((printer_ctrl_func_type) 16) 
#define CPR_WANT_ONLY_STATUS	  ((printer_ctrl_func_type) 17) 
#define CPR_SET_IMMEDIATE_MODE	  ((printer_ctrl_func_type) 18) 
#define SCSI_PRINTER_CLEAR        ((printer_ctrl_func_type) 19)
#define SCSI_POST_PENDING_BUFFERS ((printer_ctrl_func_type) 20)
#define SCSI_STOP_PRINT           ((printer_ctrl_func_type) 21)
#define PRINT_CTRL_MAX		  ((printer_ctrl_func_type) 21)

typedef struct { 
    int		  block_number; 
    unsigned char begin_block:1; 
    unsigned char end_block:1; 
    bit8	  cctl; 
} ciper_write_type; 

typedef struct { 
    set_of_32 need; 
    shortint  frequency_of_envir; 
} wants_status_type; 

typedef struct { 
    unsigned char clear_envir:1; 
    unsigned char load_default:1; 
} envir_state_type; 

typedef struct { 
    printer_ctrl_func_type ptr_ctrl_func; 
    union { 

	struct { 
	    bit8	  primary; 
	    bit8	  secondary; 
	} select_char_set; 
	bit8		  size; 
	bit8		  column; 
	bit8		  line_per_inch; 

	bit8		  scsi_clr; 

/* The following dummy booleans enable Modcal to C			      */
/*    conversions to be completed smoothly without			      */
/*    problems with boolean references.					      */

	struct { 
	    unsigned char reset_buff_clear:1; 
	    unsigned char dummy:1; 
	} cpr_clear; 
	struct { 
	    unsigned char default_state:1; 
	    unsigned char dummy1:1; 
	} cpr_begin_job; 

	struct { 
	    unsigned char interpret:1; 
	    unsigned char dummy2:1; 
	} cpr_interpret_esc_codes; 

	struct { 
	    unsigned char reset_pend_buffers:1; 
	    unsigned char dummy3:1; 
	} cpr_send_pending_buffers; 
	envir_state_type  envir_of_peripheral; 

	wants_status_type wants; 

    } u; 
} printer_ctrl_type; 

/*=======================  direct access devices ========================*/

typedef bit32 da_addr_type;	/*  direct access address	*/

typedef struct {
    int	subfunction;		/*  direct access subfunction	*/
    int	da_flags;		/*  direct access flags		*/
}  da_ctrl_type;

/*
 *  Defines for da_flags
 */
#define DA_READ		0x01	/*  Opened for read 			*/
#define	DA_WRITE	0x02	/*  Opened for write			*/
#define DA_EXCLUSIVE	0x04	/*  Opened with exclusive access	*/
#define	DA_WHOLE_DEV	0x08	/*  Entire disk section opened		*/

/*=============================== diofunc ===============================*/
 

typedef bit8 status_kind_type; 

#define DEVICE	      ((status_kind_type) 0) /* Device status proper	*/
#define JOB	      ((status_kind_type) 1) /* Status of the current job */
#define ENVIRONMENT   ((status_kind_type) 2) /* Device "environmental status" */
#define DEV_COMPOSITE ((status_kind_type) 3) /* Composite status */

/*-----------------------------------------------------------------------     */
/*  The following constants describe all of the possible IO functions	      */
/*  that are supported by the llio DMs.					      */
/*-----------------------------------------------------------------------     */

typedef bit8 dm_function_type; 

#define GENERIC_FUNC	    ((dm_function_type) 0)
#define READ_FUNC	    ((dm_function_type) 1) 
#define ADDR_READ_FUNC	    ((dm_function_type) 2) 
#define BUFF_READ_FUNC	    ((dm_function_type) 3) 
#define WRITE_FUNC	    ((dm_function_type) 4) 
#define ADDR_WRITE_FUNC	    ((dm_function_type) 5) 
#define BUFF_WRITE_FUNC	    ((dm_function_type) 6) 
#define CIPER_WRITE_FUNC    ((dm_function_type) 7) 
#define OPEN_FUNC	    ((dm_function_type) 8) 
#define CLOSE_FUNC	    ((dm_function_type) 9) 
#define GET_DEV_STATUS_FUNC ((dm_function_type) 10)
#define ADDR_CTRL_FUNC	    ((dm_function_type) 11)	
#define SERIAL_CTRL_FUNC    ((dm_function_type) 12)	
#define TERMINAL_CTRL_FUNC  ((dm_function_type) 13)	
#define PRINTER_CTRL_FUNC   ((dm_function_type) 14)	
#define TAPE_CTRL_FUNC	    ((dm_function_type) 15)
#define INIT_CONFIG_FUNC    ((dm_function_type) 16)
#define DEV_CONFIG_FUNC     ((dm_function_type) 17)
#define UNCONFIG_FUNC       ((dm_function_type) 18)
#define DA_CTRL_FUNC        ((dm_function_type) 19)
#define WRITE_FUA_FUNC	    ((dm_function_type) 20)
#define HWRELOC_FUNC        ((dm_function_type) 21)
#define WRITEV_FUNC         ((dm_function_type) 22)
#define MAX_DM_FUNC	    ((dm_function_type) 22)	

/*----------------------------------------------------------------	      */
/*									      */
/*		Native Mode IO Function Code Proper			      */
/*									      */
/*----------------------------------------------------------------	      */

typedef struct { 
    dm_function_type io_func_tag; 
    union { 
/* TO BE ADDED								      */
	int		   ctrl_word; 
	int		   sector_addr; 
	buff_data_type	   buff_data; 
	int		   w_ctrl_word; 
	int		   w_sector_addr; 
	buff_data_type	   w_buff_data; 
	ciper_write_type   ciper_write; 

	struct { 
	    status_kind_type   type_of_status; 
	    status_option_type status_option; 
	} get_dev_status_func; 
	addr_ctrl_type	   addr_ctrl; 
	serial_ctrl_type   serial_ctrl; 
	terminal_ctrl_type terminal_ctrl; 
	printer_ctrl_type  printer_ctrl; 
	tape_ctrl_type	   tape_ctrl; 
        tape_acl_ctrl_type tape_acl_ctrl;
	da_ctrl_type       da_ctrl;
	da_addr_type       da_addr;
    } u; 
    int              io_rep_count;      /* repetition count	*/
} dm_io_func_type; 

 
/*=============================== ddmiorr ===============================*/
 

typedef struct { 
    io_subq_type    reply_subq; /* Send dm_io_reply to this subqueue	      */
    addr_class_type data_class; /* Address class of the data_ptr.	      */
    data_ptr_type   data_ptr;	/* Pointer to data for transfer.	      */
    int		    data_len;	/* Length of the data in bytes.		      */
    dm_io_func_type func;	/* The function to be performed.	      */
    uintptr_t       scratch;	/* Scratch field for DM			      */
} dm_io_req_type; 

typedef struct { 
    llio_status_type reply_status;   /* Status resulting from I/O.	      */
    int		     transfer_count; /* # bytes transferred.		      */
    dm_io_func_type  func;	     /* Function just performed		      */
} dm_io_reply_type; 

 
/*=============================== dioe ===============================*/
 

/*----------------------------------------------------------------------------*/
/* The following constants describe all of the possible IO events that are    */
/* supported by the lio DMs						      */
/*----------------------------------------------------------------------------*/

#define EVENT_DEVREC	  0  
#define EVENT_TERMINAL	  1  
#define EVENT_CONSOLE_MSG 2  

typedef bit8 event_type; 
typedef bit8 term_event_type; 
typedef bit8 term_signals; 

#define CONNECT_EVENT	 0  
#define MODEM_LOST_EVENT 1  
#define SIGNAL_EVENT	 2  

typedef struct { 
    event_type dm_io_event_tag; 

    union { 
	int		devrec_info; 

	struct { 
	    term_event_type term_event_tag; 
	    term_signals    sig_id; 
	    char	    sig_char; 
	} term_event; 

	struct { 
	    shortint catalog_class; 
	    shortint index; 
	} event_console_msg; 
    } u; 
} dm_io_event_type; 
